/*
2014-2015 TEI3M RSGC ACES
Gecko Firmware
Original Author: Jackson Russett (Feb 2015)
Revision: C. D'Arcy (Apr 2015) EST/EDT Change
Revision: C. D'Arcy (May 2015) RSGC Academic Day Numbers
Revision: C. D'Arcy (Jun 2015) Substitute H for 9
Revision: C. D'Arcy (Sep 2015) 2015/2016 RSGC Day Numbers
Revision: C. D'Arcy (Oct 2015) Fixed Oct-Dec Month Display
*/
#include <Wire.h>
#include "RTClib.h"
#include "Adafruit_LEDBackpack.h"
#include "Adafruit_GFX.h"
#include "Adafruit_MCP9808.h"
Adafruit_7segment matrix = Adafruit_7segment();
Adafruit_MCP9808 tempsensor = Adafruit_MCP9808();
RTC_DS1307 rtc;
DateTime now;
int delayTime = 4000;
boolean drawDots = false;
int degreeSign = 11111011;
int H = 72;
//-----------------------------------------------------------------
// Bit mask codes. These can be used with writeDigitRaw to
// print various letters and symbols in a digit on the
// seven segment LED display.
// The first argument is the position
// on the 4-digit display, starting at 0 (far left),
// ending at 4 (far right), with position 2 being
// the colon (so you'll skip this position usually).
// The second argument is an integer that corresponds
// to the binary representation of the combination of
// 7 segments making up each digit.
//         0
//      ------
//   5  |     | 1
//      |  6  |
//      ------
//   4  |     | 2
//      |     |
//      ------   o7
//         3
// For example, to make upper case A, you want to
// light up segments 0,1,2,4,5,6.
// The binary representation would be b01110111.
//           The bit positions are -->b76543210
// The corresponding integer value is 119 for A.
// Use a binary-to-decimal calculator to convert.
// Below is a list of codes for letters and symbols
//  sevenseg.writeDigitRaw(0,119); // 119 = "A"
//  sevenseg.writeDigitRaw(0,124); // 124 = "b"
//  sevenseg.writeDigitRaw(0,57); // 57 = "C"
//  sevenseg.writeDigitRaw(0,94); // 94 = "d"
//  sevenseg.writeDigitRaw(0,121); // 121 = "E"
//  sevenseg.writeDigitRaw(0,113); // 113  = "F"
//  sevenseg.writeDigitRaw(0,125); // 125 = "G"
//  sevenseg.writeDigitRaw(0,118); // 118 = "H"
//  sevenseg.writeDigitRaw(0,116); // 116 = "h"
//  sevenseg.writeDigitRaw(0,6); // 6 = "I" aka 1
//  sevenseg.writeDigitRaw(0,4); // 4 = "i"
//  sevenseg.writeDigitRaw(0,30); // 30 = "J"
//  sevenseg.writeDigitRaw(0,56); // 56 = "L"
//  sevenseg.writeDigitRaw(0,84); // 84 = "n"
//  sevenseg.writeDigitRaw(0,92); // 92 = "o"
//  sevenseg.writeDigitRaw(0,115); // 115 = "P"
//  sevenseg.writeDigitRaw(0,103); // 103 = "q" aka 9
//  sevenseg.writeDigitRaw(0,80); // 80 = "r"
//  sevenseg.writeDigitRaw(0,109); // 109 = "S" aka 5
//  sevenseg.writeDigitRaw(0,70); // 70 = "t"
//  sevenseg.writeDigitRaw(0,28); // 28 = "u"
//  sevenseg.writeDigitRaw(0,62); // 62 = "U"
//  sevenseg.writeDigitRaw(0,110); // 110 = "y"
//  sevenseg.writeDigitRaw(0,64); // 64 = "-" negative sign
//  sevenseg.writeDigitRaw(0,34); // 34 = " " " double quote
//  sevenseg.writeDigitRaw(0,32); // 32 = "'" apostrophe (upper left)
//  sevenseg.writeDigitRaw(0,2); // 2 = "'" apostrophe (upper right)
//  sevenseg.writeDigitRaw(0,8); // 8 = "_" underscore
//  sevenseg.writeDigitRaw(0,1); // 1 = "-" overbar
//  sevenseg.writeDigitRaw(0,16); // 16 = lower left bar
//  sevenseg.writeDigitRaw(0,4); // 4 = lower right bar
//  sevenseg.writeDigitRaw(0,128); // 128 = "." decimal
//  sevenseg.writeDigitRaw(0,0); // blank
//  sevenseg.writeDigitRaw(2,255); // 255 = ":"  colon, always position 2
/**********************************************************************************
   Always follow a writeDigitRaw command with the
   writeDisplay(); command to push the data to the
   display.
***********************************************************************************/
// ------------------------2015/2016 Day Calendar----------------------------------
int schoolYear[12][32] = {
  {9, 9, 9, 9, 0, 4, 1, 2, 3, 9, 9, 4, 1, 2, 3, 4, 9, 9, 1, 2, 3, 4, 1, 9, 9, 2, 3, 4, 1, 2, 9, 9}, // January
  {9, 3, 4, 1, 2, 3, 9, 9, 4, 1, 2, 3, 9, 9, 9, 9, 4, 1, 2, 3, 9, 9, 4, 1, 2, 3, 4, 9, 9, 1},             // February
  {9, 2, 3, 4, 1, 9, 9, 2, 3, 4, 1, 2, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 0, 3, 4, 1},    // March
  {9, 2, 9, 9, 3, 4, 1, 2, 3, 9, 9, 4, 1, 2, 3, 4, 9, 9, 1, 2, 3, 4, 1, 9, 9, 2, 3, 4, 1, 2, 9},    // April
  {9, 9, 3, 4, 1, 2, 3, 9, 9, 4, 1, 2, 3, 4, 9, 9, 1, 2, 3, 4, 1, 9, 9, 9, 2, 3, 4, 1, 9, 9, 2, 3}, // May
  {9, 4, 1, 2, 9, 9, 9, 3, 4, 1, 2, 3, 9, 9, 4, 1, 2, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9},    // June
  {9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9},   // July
  {9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9},   // August
  {9, 9, 9, 9, 9, 9, 9, 9, 9, 0, 1, 2, 9, 9, 3, 4, 1, 2, 3, 9, 9, 4, 1, 2, 3, 5, 9, 9, 4, 1, 2},    // September
  {9, 3, 4, 9, 9, 1, 2, 3, 4, 1, 9, 9, 9, 2, 3, 4, 1, 9, 9, 2, 3, 4, 1, 2, 9, 9, 3, 4, 1, 2, 3, 9}, // October
  {9, 9, 4, 1, 2, 3, 4, 9, 9, 1, 2, 3, 9, 9, 9, 9, 4, 1, 2, 3, 4, 9, 9, 1, 2, 3, 4, 1, 9, 9, 2},    // November
  {9, 3, 4, 1, 2, 9, 9, 3, 4, 1, 2, 3, 9, 9, 4, 1, 2, 3, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9}  // December
};
// --------------------------------------------------------------------------------
// Added to account for EST/EDT changes Toronto
// Resource:  http://www.epochconverter.com/
// Reference:  http://www.timeanddate.com/time/zone/canada/toronto
unsigned long UTCs[] = {
  1425798000L /*Sun Mar 8 2015, 2:00 am*/,
  1446361200L /*Sun Nov 1 2015: 2:00 am*/,
  1457852400L /*Sun Mar 13 2016: 2:00 am*/,
  1478415600L /*Sun Nov 6 2016: 2:00 am*/,
  1489302000L /*Sun Mar 12 2017: 2:00 am*/,
  1509865200L /*Sun Nov 5 2017: 2:00 am*/,
  1520751600L /*Sun Mar 11 2018: 2:00 am*/,
  1541314800L /*Sun Nov 4 2018: 2:00 am*/,
  1741503600L /*Sun Nov 4 2025: 2:00 am*/
};
// ---------------------------------------------------------------
void setup() {
  Serial.begin(57600);
  matrix.begin(0x70);
  Wire.begin();
  if (!tempsensor.begin()) {
    Serial.println("Couldn't find MCP9808!");
    while (1);
  }
}

void loop() {
  showTime();
  for (int i = 0; i < 4; i++)
    showTemp();
  showDayNum();
  showDate();
}

// Added May 12, 2015 to determine time adjustment as a result of EST > EDT > EST...
int getAdjustment(unsigned long currentTime) {
  int i = 0;
  while (currentTime > UTCs[i + 1])
    i++;
  // index is either even (no adjustment) or odd (add 11 - same as -1 on 12 hour display)
  return (i % 2) * 11;
}

void showTime() {
  for (int i = 0; i < 6; i++) {
    now = rtc.now();

    // ---------Jackson's original statements --------
    //matrix.print((now.hour() * 100) + now.minute());
    //if (now.hour() < 10) {
    //  matrix.writeDigitNum(0, 0);
    //}
    //------------------------------------------------
    //== Modified to account for EST > DST > EST...===
    int adjustment = getAdjustment(now.unixtime());
    int hourAdj = ((now.hour() + adjustment) % 12);
    if (hourAdj == 0) hourAdj = 12;
    matrix.print( hourAdj * 100 + now.minute());
    //================================================

    switching();
    matrix.drawColon(drawDots);
    matrix.writeDisplay();
    delay(delayTime / 2);
    switching();
    matrix.drawColon(drawDots);
    matrix.writeDisplay();
    delay(delayTime / 2);
  }
}

void switching() {
  drawDots = !drawDots;
}

void showTemp() {
  float c = tempsensor.readTempC();
  matrix.print(c - 3.8); //Adjusted
  matrix.writeDigitRaw(4, degreeSign);
  matrix.writeDisplay();
  delay(delayTime);
}

void showDayNum() {
  int thisMonth = now.month();
  int thisDay = now.day();
  matrix.writeDigitRaw(0, 94);
  matrix.writeDigitRaw(1, 119);
  matrix.writeDigitRaw(3, 0b01101110);
  int dayNum = schoolYear[thisMonth - 1][thisDay];
  if (dayNum == 9)
    matrix.writeDigitRaw(4, 118);  // 'H' - 118
  else
    matrix.writeDigitNum(4, dayNum);
  matrix.writeDisplay();
  delay(delayTime);
}

void showDate() {
  now = rtc.now();
  //Serial.println(now.unixtime());
  int thisMonth = now.month();
  if (thisMonth < 10) {
    matrix.writeDigitNum(0, 0);
    matrix.writeDigitNum(1, now.month(), true);
  } else {
    matrix.writeDigitNum(0, 1);
    matrix.writeDigitNum(1, thisMonth % 10, true);
  }
  matrix.writeDigitNum(3, now.day() / 10);
  matrix.writeDigitNum(4, now.day() % 10);
  matrix.writeDisplay();
  delay(delayTime << 1);

  matrix.print(now.year());
  matrix.writeDisplay();
  delay(delayTime);
}



